SystemOrganization addCategory: #ConfigurationOfMabinogi!

Object subclass: #ConfigurationOfMabinogi
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMabinogi'!

!ConfigurationOfMabinogi class methodsFor: 'development support' stamp: 'StuartHerring 2/10/2012 16:46'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMabinogi class methodsFor: 'private' stamp: 'StuartHerring 2/10/2012 16:46'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMabinogi class methodsFor: 'private' stamp: 'StuartHerring 2/10/2012 16:46'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMabinogi class methodsFor: 'private' stamp: 'StuartHerring 2/10/2012 16:46'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMabinogi class methodsFor: 'metacello tool support' stamp: 'StuartHerring 2/10/2012 16:46'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMabinogi class methodsFor: 'loading' stamp: 'StuartHerring 2/10/2012 16:46'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMabinogi class methodsFor: 'loading' stamp: 'StuartHerring 2/10/2012 16:46'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMabinogi class methodsFor: 'loading' stamp: 'StuartHerring 2/10/2012 16:46'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMabinogi class methodsFor: 'accessing' stamp: 'StuartHerring 2/10/2012 16:46'!
project

	^self new project! !

!ConfigurationOfMabinogi class methodsFor: 'development support' stamp: 'StuartHerring 2/10/2012 16:46'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMabinogi methodsFor: 'baselines' stamp: 'StuartHerring 2/15/2012 20:09'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Mabinogi'.
		spec 
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Base' 'JQuery-Core') ];
		 	project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'];
			project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Mabinogi-Core';
			package: 'Mabinogi-Web' with: [
				spec requires: #('Mabinogi-Core' 'Seaside30' ). ];
			package: 'Mabinogi-Test' with: [
				spec requires: #('Mocketry' 'Mabinogi-Core' 'Mabinogi-Web' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Mabinogi-Core' );
			group: 'Tests' with: #('Mabinogi-Test' );
			group: 'Full' with: #('Core' 'Mabinogi-Web' );
			group: 'Development' with: #('Full' 'Tests' 'Seaside30 Development'). ].
! !

!ConfigurationOfMabinogi methodsFor: 'baselines' stamp: 'StuartHerring 3/10/2012 14:53'!
baseline02: spec
	<version: '0.2-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://stuartherring.net/mc/Mabinogi'.
		spec 
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Base' 'JQuery-Core') ];
		 	project: 'Seaside30 Development' copyFrom: 'Seaside30' with: [
				spec
					loads: 'Development'];
			project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: '4.4.5';
					repository: 'http://www.squeaksource.com/MetacelloRepository'];
			project: 'Magma' with: [
				spec
					className: 'ConfigurationOfMagma';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository';
					loads: #('Server') ];
			project: 'Mocketry' with: [
				spec
					className: 'ConfigurationOfMocketry';
					versionString: #'stable';
					loads: #('Core');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Bootstrap' with: [
					spec requires: #('Seaside30')];
			package: 'Mabinogi-Core' with: [
					spec requires: #('OSProcess' 'Magma')];
			package: 'Mabinogi-Web' with: [
				spec requires: #('Mabinogi-Core' 'Bootstrap' 'Seaside30' ). ];
			package: 'Mabinogi-Test' with: [
				spec requires: #('Mabinogi-Core' 'Mabinogi-Web' 'Mocketry' ). ].
		spec 
			group: 'default' with: #('Development' );
			group: 'Core' with: #('Mabinogi-Core' );
			group: 'Tests' with: #('Mabinogi-Test' );
			group: 'Full' with: #('Core' 'Mabinogi-Web' );
			group: 'Development' with: #('Full' 'Tests' 'Seaside30 Development'). ].
! !

!ConfigurationOfMabinogi methodsFor: 'symbolic versions' stamp: 'StuartHerring 2/15/2012 20:13'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.2'.
! !

!ConfigurationOfMabinogi methodsFor: 'accessing' stamp: 'StuartHerring 2/10/2012 16:46'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMabinogi methodsFor: 'symbolic versions' stamp: 'StuartHerring 2/15/2012 20:12'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfMabinogi methodsFor: 'versions' stamp: 'StuartHerring 2/15/2012 20:12'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Initial Version
Should depend on SIXX not shout - stupid copy paste error
Should depend on SIXX not shout - stupid copy paste error
Esnure tests pull in Mocketry
Tidy up dependencies a little
SC-10
Improvements to allow classes to inherit definitions, and to override base definitions.
Also added ignore mechanism	

SC-14
Created the beginnings of a generic Table widget.  Required some changes to the way definitions were retrieved.
Will need to think the Definition model soon, it''s getting ugly

SC-16, SC-10
Added new MbUpdateDefinedObjectCommand to apply changes to an object.
Minor fix to the MbDropdownField to ensure its initialized correctly'.
		spec author: 'StuartHerring'.
		spec timestamp: '2/15/2012 20:02'.
		spec 
			package: 'Mabinogi-Core' with: 'Mabinogi-Core-StuartHerring.7';
			package: 'Mabinogi-Web' with: 'Mabinogi-Web-StuartHerring.3';
			package: 'Mabinogi-Test' with: 'Mabinogi-Test-StuartHerring.4'. ].
! !

!ConfigurationOfMabinogi methodsFor: 'versions' stamp: 'StuartHerring 3/16/2012 17:37'!
version02: spec
	<version: '0.2' imports: #('0.2-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ' - opening for milestone 2 work
Major work done for milestone 2, checking in
SC-5, SC-18, SC-19
Implemented support for Magma persistence, added Bootstrap support and integrated with login process
SC-32
	Definitions are now explicitly declared, rather than detected.  This also allows an implicit order to be set
SC-32
Update the form component to ensure it uses the fields in the correct order.  Also improve display of defintions for debugging purposes
SC-29
Updates to allow for embedded forms - automatically detects when a field is another mbObject
SC-29
Replace automatic detection with explicit declaration via an <embed> pragma.  Auto detection was causing weird effects
SC-29
Removed additional method I forgot to removelast time
Minor improvements to the transaction handling
Fixed a missing instvar'.
		spec author: 'StuartHerring'.
		spec timestamp: '3/16/2012 17:37'.
		spec 
			package: 'Bootstrap' with: 'Bootstrap-StuartHerring.1';
			package: 'Mabinogi-Core' with: 'Mabinogi-Core-StuartHerring.14';
			package: 'Mabinogi-Web' with: 'Mabinogi-Web-StuartHerring.9';
			package: 'Mabinogi-Test' with: 'Mabinogi-Test-StuartHerring.6'. ].
! !
